﻿Public Class frmPrehMat

#Region "Udalosti formulare"
    Private Sub frmPrehMat_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        Me.Cursor = Cursors.WaitCursor


        'TODO: This line of code loads data into the 'DsData.tblPalety' table. You can move, or remove it, as needed.
        Me.TblPaletyTableAdapter.Fill(Me.DsData.tblPalety)
        'TODO: This line of code loads data into the 'DsData.tblMaterial' table. You can move, or remove it, as needed.
        Me.TblMaterialTableAdapter.Fill(Me.DsData.tblMaterial)

        rdbRaditCislaMat.Checked = True

        Me.Cursor = Cursors.Default
    End Sub

#End Region



#Region "grbRazeni"
    Private Sub rdbRaditCislaMat_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles rdbRaditCislaMat.CheckedChanged
        If rdbRaditCislaMat.Checked Then
            Me.TblMaterialBindingSource.Sort = "Cislo_Mat"
            Me.dgvTblMaterial.Focus()
        End If
    End Sub

    Private Sub rdbRaditNazevMat_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles rdbRaditNazevMat.CheckedChanged
        If rdbRaditNazevMat.Checked Then
            Me.TblMaterialBindingSource.Sort = "Nazev_Mat"
            Me.dgvTblMaterial.Focus()
        End If
    End Sub

#End Region

#Region "Navigace"

#Region "Ridici tlacitka"
    Private Sub btnZavrit_Click(sender As System.Object, e As System.EventArgs) Handles btnZavrit.Click
        'otevrit formular frmRidici
        Me.Cursor = Cursors.WaitCursor
        Dim frmRidici As New frmRidici
        frmRidici.MdiParent = MyFrmHlavni
        frmRidici.Show()

        Me.Close()   'zavrit tento formular
        Me.Cursor = Cursors.Default
    End Sub

    Private Sub btnPrvni_Click(sender As System.Object, e As System.EventArgs) Handles btnPrvni.Click
        'najit prvni zaznam
        Me.TblMaterialBindingSource.MoveFirst()
        Me.dgvTblMaterial.Focus()
    End Sub

    Private Sub btnPosledni_Click(sender As System.Object, e As System.EventArgs) Handles btnPosledni.Click
        'najit posledni zaznam
        Me.TblMaterialBindingSource.MoveLast()
        Me.dgvTblMaterial.Focus()
    End Sub

    Private Sub btnKomentar_Click(sender As System.Object, e As System.EventArgs) Handles btnKomentar.Click
        Me.txtKoment.Visible = Not Me.txtKoment.Visible
    End Sub

#End Region

#Region "Hledani"
    Private Sub btnNajit_Click(sender As System.Object, e As System.EventArgs) Handles btnNajit.Click
        'aktivace tlacitek
        Me.pnlNavig.Enabled = False
        Me.pnlEdit.Enabled = False
        Me.btnZavrit.Enabled = False
        Me.grbRazeni.Enabled = False

        'zviditelneni zadavaciho pole
        Me.pnlNajit.Visible = True
        Me.txtNajit.Text = ""

        Me.txtNajit.Focus()
    End Sub

    Private Sub txtNajit_LostFocus(sender As Object, e As System.EventArgs) Handles txtNajit.LostFocus
        'aktivace tlacitek
        Me.pnlNavig.Enabled = True
        Me.pnlEdit.Enabled = True
        Me.btnZavrit.Enabled = True
        Me.grbRazeni.Enabled = True

        Dim foundIndex As Integer   'cislo radku odpovidajici kriteriu
        If rdbRaditCislaMat.Checked Then
            'foundIndex = TblMaterialBindingSource.Find("Cislo_Mat", Me.txtNajit.Text) 'presne hledani
            foundIndex = SearchRows(TblMaterialBindingSource, "Cislo_Mat", Me.txtNajit.Text)
        ElseIf rdbRaditNazevMat.Checked Then
            'foundIndex = TblMaterialBindingSource.Find("Nazev_Mat", Me.txtNajit.Text)
            foundIndex = SearchRows(TblMaterialBindingSource, "Nazev_Mat", Me.txtNajit.Text)
        End If
        If foundIndex > -1 Then
            TblMaterialBindingSource.Position = foundIndex
        End If
        'zviditelneni zadavaciho pole
        Me.pnlNajit.Visible = False
        Me.txtNajit.Text = ""
    End Sub

#End Region

#Region "Editace zaznamu"

#Region "Ridici tlacitka"
    Private Sub btnOdstranit_Click(sender As System.Object, e As System.EventArgs) Handles btnOdstranit.Click
        Dim vys As MsgBoxResult
        Dim dvPalety As New DataView(Me.DsData.tblPalety)
        dvPalety.RowFilter = "Cislo_Mat = '" & Me.txtCislo_Mat.Text & "'"
        If dvPalety.Count > 0 Then
            'Material v nektere palete nalezen
            MsgBox("Nelze zrušit. Materiál je v některé paletě", MsgBoxStyle.Exclamation)
        Else
            'Material v zadne palete nenalezen
            vys = MsgBox("Opravdu chcete smazat tuto položku", MsgBoxStyle.Information + MsgBoxStyle.YesNo + MsgBoxStyle.DefaultButton2, "Smazat")
            If vys = MsgBoxResult.Yes Then
                'muzeme smazat material
                TblMaterialBindingSource.RemoveCurrent()
            End If
        End If
    End Sub
#End Region
#End Region


#End Region

#Region "Zmena zaznamu"
    Private Sub TblMaterialBindingSource_PositionChanged(sender As Object, e As System.EventArgs) Handles TblMaterialBindingSource.PositionChanged
        Cursor.Current = Cursors.WaitCursor

        If TblMaterialBindingSource.Current("Koment").ToString.Length > 0 Then
            Me.btnKomentar.Text = "KOMENTÁŘ"    'existuje komentar
        Else
            Me.btnKomentar.Text = "Komentář"    'neexistuje komentar
        End If

        'vypocitame celkove mnozstvi pomoci agregacni funkce
        Dim strSQL As String
        strSQL = "SELECT SUM(Mnoz_pa) AS CelkoveMnozstvi FROM tblPalety WHERE Cislo_Mat = '" & _
                    Me.TblMaterialBindingSource.Current("Cislo_Mat") & "' GROUP BY Cislo_Mat"

        ''nadefinujeme sluzbu pro pristup k databazi
        'Dim builder As New System.Data.OleDb.OleDbConnectionStringBuilder
        'builder.Provider = "Microsoft.ACE.OLEDB.12.0"   'Pristup do Access typu accdb
        'builder.DataSource = "|DataDirectory|\Data\Data.accdb"

        'inicializace objektu spojení na databázi
        Dim oledbcon As New OleDb.OleDbConnection
        ' oledbcon.ConnectionString = builder.ConnectionString
        oledbcon.ConnectionString = TblMaterialTableAdapter.Connection.ConnectionString
        oledbcon.Open() 'pomocí dat z ConnectionStringu spojení otevřeme

        Dim cmd As New OleDb.OleDbCommand(strSQL, oledbcon)     'deklarace prikazu nad databazi pomoci SQL
        Dim dataReader As OleDb.OleDbDataReader = cmd.ExecuteReader()   'spuštění dotazu a vytvoření objektu na čtení řádků
        dataReader.Read()   'nacteme data z databaze s definovanym SQL prikazem

        'ziskame celkove mnozstvi
        Dim CelkoveMnozstvi As Integer
        If dataReader.HasRows Then
            'existují palety vybraneho materialu
            CelkoveMnozstvi = dataReader("CelkoveMnozstvi")
        Else
            'neexistují palety vybraneho materialu
            CelkoveMnozstvi = 0
        End If
        Me.txtMnoz_Celk.Text = CelkoveMnozstvi

        dataReader.Close()          '// nejdříve uzavřeme aktuální dotaz
        oledbcon.Close()    '// a pak i spojení

        Cursor.Current = Cursors.Default
    End Sub
#End Region


End Class